# holm-voice.tcl by Stian Holm
# Created for WarpCrew INFOBOT Service.
# (C) tw|ster 2000
##
# Released : May 9 2000
# Http://stians.toyb0x.net
# Email: stian@realtime.no
##
#
# .:Version:.
#
#  v1.0 [16.January 2000]
#   - Added protection so commands
#     dont have any affect on ops,
#     voice, owners and botnick
#
#  v2.0 [23.April 2000]
#   - Fixed the ban error.
#
#  v3.0 [9.May 2000]
#   - Made it public. Wrote all the help
#     stuff.
#
#  v4.0 [19.May 2000]
#   - Fixed it so it works on either 1.1.5
#     or 1.3.x/1.4.x eggdrop versions too.
#
set ver "v4.0"
#
##
#
# .:Info:.
#
#  This tcl script is made for eggdrop
# version 1.1.5/1.3.x/1.4.x! If this
# script should work then the user have
# to be added +4 (or +V if it's for either
# 1.3.x or 1.4.x!) on the channel you want
# him to have access to do public commands
# like !kick , !ban , !topic etc.
#
#  The user has to have a vertified host
# and voice on the channel for him to be
# able to use the commands. And he also
# needs the voiceflag on the channel too.
#
#  People who tryes to !kick or !ban the
# bot who have the script loaded or the
# Author will loos their flag on the
# channel they where added on...
#
#  So if you put you're name in the Author
# variable field then you're nick is
# protected! The user will also get
# important information about removing
# flags from users and more...
#
##
#
# .:Todo:.
#
#  Well, there is a lot to do, if you
# got any idea just write it in a mail
# to me on, stian@realtime.no
#
##
#
# .:Greets:.
#
# Dettsh - thanks for all the help =)
# fluffy - a genuine friend ...
# MrWarlock - my private rhapsodomancy ...
#
##
#
# .:Words:.
#
#  Well, enjoy using my script. And
# remember, feel free to become
# lammer by making a copy of this
# script in you're name.
#
# - Stian Holm aka tw|ster
##

#**********#
# Settings #
#**********#

# What eggdrop version do you use? 1.1.5 [0] or 1.3.x/1.4.x [1]
set eggver 1

# The VoiceFlag
if {$eggver} {
	set flag7 V
	set voice_flag "V"
} else {
	set flag7 4
	set voice_flag "4"
}

# How long do you want bans to last?
set bantime "20"

# The nick of the Author!
set author "tw\|ster"

#************************#
# DO NOT EDIT UNDERNEATH #
#************************#

putlog "holm-voice.tcl $ver by tw|ster (Stian Holm) loaded ..."

bind msg - voiceop voicewithpass
proc voicewithpass {nick uhost handle arg} {
global voice_flag
	set blubb [lindex $arg 0]
	set pass [lindex $arg 1]
	set channel [lindex $arg 2]
	if {$handle == "*"} {
		putlog "voiceop: $nick ($handle) Wanted voice... (wrong host)"
	return 0
	}
	if {[validuser $blubb]} {
		if {[passwdok $blubb $pass] == 1} {
			if {([matchattr $handle $voice_flag]) || ([matchchanattr $handle $voice_flag $channel])} {
				if {[isvoice $nick $channel] == "1"} {
					putserv "notice $nick :You allready got voice... Moron!"
					putlog "voiceop: told $nick ($handle) that he/she was a moron! (allready got voice)"
				return 0
				}
				putserv "notice $nick :Welcome to the world of Twisted Metal Sickness!"
				pushmode $channel +v $nick
				putlog "voiceop: gave $nick ($handle) voice in $channel"
			return 0
			}
			putserv "notice $nick :You dont have access in that channel!"
		return 0
		}
		putserv "notice $nick :Access denied!"
		putlog "voicehack: $nick used handle: $blubb password: $pass channel: $channel"
	return 0
	}
	putserv "notice $nick :voiceop <handle> <password> <channel>"
return 0
}

set cmdchar "@"

proc char { } {
global cmdchar
return $cmdchar
}

bind pub - !kick holm-pub_kick
proc holm-pub_kick {nick host handle channel vars} {
global botnick voice_flag author
	if {[matchchanattr $handle $voice_flag $channel]} {
		if {[isvoice $nick $channel]} {
			set who [lindex $vars 0]
			set reason [lrange $vars 1 end]
			if {$who == ""} {
				putserv "notice $nick :Usage: !kick <nick> <reason>"
			return 0
			}
			if {![botisop $channel]} {
			return 0
			}
			if {[string toupper $who] == [string toupper $botnick]} {
				putserv "KICK $channel $nick :dont even try to kick me!"
				chattr $nick -$voice_flag $channel
				putserv "PRIVMSG $author : $nick just tried to kick me, removed +$voice_flag on $channel ..."
			return 0
			}
			if {$who == "$author"} {
				putserv "KICK $channel $nick :dont even try to kick $author ..."
				chattr $nick -$voice_flag $channel
				putserv "PRIVMSG $author : $nick just tried to kick you, removed +$voice_flag on $channel ..."
			return 0
			}
			if {[isop [lindex $vars 0] $channel]} {
				putserv "notice $nick :You may not kick him!"
				putserv "notice $vars :$nick just tried to make me kick you."
			return 0
			}
			if {[isvoice [lindex $vars 0] $channel]} {
				putserv "notice $nick :You may not kick him!"
				putserv "notice $vars :$nick just tried to make me kick you."
			return 0
			}
			if {![onchan $who $channel]} {
			return 0
			}
			if {$reason == ""} {
				putserv "KICK $channel $who :requested by $nick"
			return 0
			}
			putserv "KICK $channel $who :$reason (requested by $nick)"
		return 0
		}
	}
}

bind pub - !ban holm-pub_ban
proc holm-pub_ban {nick host handle channel vars} {
global botnick bantime voice_flag author
	if {[matchchanattr $handle $voice_flag $channel]} {
		if {[isvoice $nick $channel]} {
			set who [lindex $vars 0]
			set reason [lrange $vars 1 end]
			set uts "*!*@[lindex [split [getchanhost $who $channel] "@"] end]"
			if {$who == ""} {
				putserv "notice $nick :Usage: !kick <nick> <reason>"
			return 0
			}
			if {$uts == "*!*@*"} {
			return 0
			}
			if {![botisop $channel]} {
			return 0
			}
			if {![onchan [lindex $vars 0] $channel]} {
			return 0
			}
			if {[string toupper $who] == [string toupper $botnick]} {
				putserv "KICK $channel $nick :dont even try to ban me!"
				chattr $nick -$voice_flag $channel
				putserv "PRIVMSG $author : $nick just tried to ban me, removed +$voice_flag on $channel ..."
			return 0
			}
			if {$who == "$author"} {
				putserv "KICK $channel $nick :dont even try to kick $author ..."
				chattr $nick -$voice_flag $channel
				putserv "PRIVMSG $author : $nick just tried to ban you, removed +$voice_flag on $channel ..."
			return 0
			}
			if {[isop [lindex $vars 0] $channel]} {
				putserv "notice $nick :You may not ban him!"
				putserv "notice $vars :$nick just tried to make me ban you."
			return 0
			}
			if {[isvoice [lindex $vars 0] $channel]} {
				putserv "notice $nick :You may not ban him!"
				putserv "notice $vars :$nick just tried to make me ban you."
			return 0
			}
			if {$reason == ""} {
				set newreason "banned by $nick"
				newchanban $channel $uts $nick $newreason $bantime
			return 0
			}
			newchanban $channel $uts $nick $reason $bantime
		return 0
		}
	}
}

bind pub - !topic holm-pub_topic
proc holm-pub_topic {nick uhost handle channel text} {
global botnick voice_chan voice_flag
	if {[matchchanattr $handle $voice_flag $channel]} {
		if {[isvoice $nick $channel]} {
			if {$text == ""} {
				puthelp "NOTICE $nick :Usage: !topic <topic>"
			return 0
			}
			if {[isop $botnick $channel] == "0"} {
				puthelp "NOTICE $nick :Sorry, I'm not a op on $channel."
			return 0
			}
			if {[isop $botnick $channel] == "1"} {
				putserv "TOPIC $channel :$nick: $text"
				putlog "#$nick# !topic $text"
			}
		}
	}
}